clear all;

N1=8; % n-k
N2=12;% n
LEN=10;%number of words of length N2 that will be generated

H=zeros(N1,N2);
G=zeros(N2-N1,N2);
t=zeros(1,N2);
c=zeros(1,N2);


fid = fopen('H.txt','r');
H=fscanf(fid,'%d ',[N1,N2]);%Matrix H is read from a file H.txt
fclose(fid);

fid = fopen('G.txt','r');
G=fscanf(fid,'%d ',[N2-N1,N2]);%Matrix G is read from a file G.txt
fclose(fid);

HT=H';   
S0=zeros(N2-N1,N1);
 

sig=zeros(1,10);
for q1=6:1.0:9
 
Sigma=0.1*q1;
Inputword=zeros(N2-N1,LEN);
Inputword =fix(2*rand(N2-N1,LEN));
c=zeros(N2,LEN);
t=zeros(N2,LEN);

for q2=1:LEN
   Inputword(:,q2)'*G;
   
   c(:,q2)=mod((Inputword(:,q2)'*G)',2);
 end
t(find(c==1))=1;
t(find(c==0))=-1;  
Ruido = Sigma*randn(N2,LEN);
r=t+Ruido;     

arch='Inputword_';%Inputword is saved in a file Inputword_q1.txt for different values of q1
i1=10*q1;
fid = fopen([arch num2str(i1)],'w');
fprintf(fid,'%d ',Inputword);
fclose(fid);
   
arch='r_';
i1=10*q1;
fid = fopen([arch num2str(i1)],'w');%r is saved in a file Inputword_q1.txt for different values of q1
fprintf(fid,'%f ',r);
fclose(fid);
   
arch='Outputword_';%Outputword is saved in a file Inputword_q1.txt for different values of q1
i1=10*q1;
fid = fopen([arch num2str(i1)],'w');
fprintf(fid,'%d ',t);
fclose(fid);

end
